"use strict";
/**
 * @module webdnn
 */
/** Don't Remove This comment block */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var webgl_handler_1 = require("../webgl_handler");
var buffer_1 = require("./buffer");
/**
 * @protected
 */
var BufferWebGL = /** @class */ (function (_super) {
    __extends(BufferWebGL, _super);
    function BufferWebGL(byteLength, textureWidth, textureHeight, name, array, channelMode) {
        var _this = _super.call(this, byteLength, 'webgl') || this;
        _this._texture = null;
        _this.readTextureUnitIndices = [];
        _this.isBoundToDrawFrameBuffer = false;
        _this.handler = webgl_handler_1.default.getInstance();
        _this.name = name;
        _this.channelMode = channelMode;
        switch (channelMode) {
            case 'RGBA':
                _this.elementsPerPixel = 4;
                break;
            case 'R':
                _this.elementsPerPixel = 1;
                break;
            default:
                throw Error('Unknown channel mode');
        }
        if (webgl_handler_1.isWebGL2(_this.handler.gl)) {
            switch (channelMode) {
                case 'RGBA':
                    _this.textureFormat = _this.handler.gl.RGBA;
                    _this.textureInternalFormat = _this.handler.gl.RGBA32F;
                    _this.pixelStride = 4;
                    break;
                case 'R':
                    _this.textureFormat = _this.handler.gl.RED;
                    _this.textureInternalFormat = _this.handler.gl.R32F;
                    _this.pixelStride = 1;
                    break;
                default:
                    throw Error('Unknown channel mode');
            }
        }
        else {
            // In WebGL1, always RGBA channel mode is specified. If R channel mode is specified in graph descriptor,
            // other 3 channels are not used.
            _this.textureFormat = _this.handler.gl.RGBA;
            _this.textureInternalFormat = _this.handler.gl.RGBA;
            _this.pixelStride = 4;
        }
        if (_this.pixelStride < _this.elementsPerPixel)
            throw Error('elementsPerPixel must be smaller than pixelStride');
        _this.array = array || new Float32Array(_this.length);
        _this.textureWidth = textureWidth;
        _this.textureHeight = textureHeight;
        return _this;
    }
    Object.defineProperty(BufferWebGL.prototype, "texture", {
        get: function () {
            return this._texture;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(BufferWebGL.prototype, "length", {
        get: function () {
            return this.byteLength / Float32Array.BYTES_PER_ELEMENT;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * Write contents onto specified position synchronously.
     *
     * @param {ArrayBufferView} src contents source buffer
     * @param {number} offset position where contents are written on
     */
    BufferWebGL.prototype.write = function (src, offset) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.array.set(src, offset);
                        return [4 /*yield*/, this.syncWriteViews()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Read contents from specified position synchronously.
     *
     * @param {Float32ArrayConstructor | Int32ArrayConstructor} dst buffer where contents are written on
     * @param {number} offset position where contents are read from
     * @param {length} length contents length
     */
    BufferWebGL.prototype.read = function (dst, offset, length) {
        if (offset === void 0) { offset = 0; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (dst !== Float32Array)
                            throw new Error('Currently, only Float32Array is supported for parameter \'dst\'.');
                        return [4 /*yield*/, this.syncReadViews()];
                    case 1:
                        _a.sent();
                        new Float32Array(this.array.buffer, offset * Float32Array.BYTES_PER_ELEMENT, length);
                        return [2 /*return*/];
                }
            });
        });
    };
    BufferWebGL.prototype.getWriteView = function (offset, length, type) {
        return new type(this.array.buffer, offset * type.BYTES_PER_ELEMENT, length);
    };
    ;
    BufferWebGL.prototype.getReadView = function (offset, length, type) {
        return new type(this.array.buffer, offset * type.BYTES_PER_ELEMENT, length);
    };
    /**
     * Sync buffered data into memory.
     *
     * @see Buffer#getWriteView
     */
    BufferWebGL.prototype.syncWriteViews = function () {
        return __awaiter(this, void 0, void 0, function () {
            var gl, tmp, tmp2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        gl = this.handler.gl;
                        if (!this.texture)
                            this.allocateTexture();
                        tmp = this.pack(this.array);
                        if (tmp.length != this.textureWidth * this.textureHeight * this.pixelStride) {
                            tmp2 = new Float32Array(this.textureWidth * this.textureHeight * this.pixelStride);
                            tmp2.set(tmp, 0);
                            tmp = tmp2;
                        }
                        return [4 /*yield*/, this.bindToReadTexture(9)];
                    case 1:
                        _a.sent(); //TODO: texture unit 9 is always available?
                        gl.texSubImage2D(gl.TEXTURE_2D, 0, 0, 0, this.textureWidth, this.textureHeight, this.textureFormat, gl.FLOAT, tmp);
                        this.unbindFromReadTexture();
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Sync memory data into buffer view.
     *
     * @see Buffer#getReadView
     */
    BufferWebGL.prototype.syncReadViews = function () {
        return __awaiter(this, void 0, void 0, function () {
            var gl, ELEMENT_PER_PIXEL, FORMAT, tmp;
            return __generator(this, function (_a) {
                gl = this.handler.gl;
                ELEMENT_PER_PIXEL = 4;
                FORMAT = gl.RGBA;
                tmp = new Float32Array(this.textureWidth * this.textureHeight * ELEMENT_PER_PIXEL);
                this.bindToDrawTexture();
                gl.readPixels(0, 0, this.textureWidth, this.textureHeight, FORMAT, gl.FLOAT, tmp);
                this.unbindFromDrawTexture();
                tmp = this.unpack(tmp);
                this.array.set(tmp.slice(0, this.length), 0);
                return [2 /*return*/];
            });
        });
    };
    BufferWebGL.prototype.bindToReadTexture = function (unit) {
        return __awaiter(this, void 0, void 0, function () {
            var gl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.isBoundToDrawFrameBuffer)
                            throw Error('This buffer is already registered as draw buffer. ' +
                                'You may forgot to unbind the binding while previous operations.');
                        gl = this.handler.gl;
                        if (!!this.texture) return [3 /*break*/, 2];
                        this.allocateTexture();
                        return [4 /*yield*/, this.syncWriteViews()];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        gl.activeTexture(gl.TEXTURE0 + unit);
                        gl.bindTexture(gl.TEXTURE_2D, this.texture);
                        this.readTextureUnitIndices.push(unit);
                        return [2 /*return*/];
                }
            });
        });
    };
    BufferWebGL.prototype.unbindFromReadTexture = function () {
        var gl = this.handler.gl;
        for (var _i = 0, _a = this.readTextureUnitIndices; _i < _a.length; _i++) {
            var unit = _a[_i];
            gl.activeTexture(gl.TEXTURE0 + unit);
            gl.bindTexture(gl.TEXTURE_2D, null);
        }
        this.readTextureUnitIndices = [];
    };
    BufferWebGL.prototype.bindToDrawTexture = function () {
        if (this.readTextureUnitIndices.length > 0)
            throw Error('This buffer is already registered as read buffer. ' +
                'You cannot bind a texture as both read and draw texture buffer at same time.');
        if (this.isBoundToDrawFrameBuffer)
            throw Error('This buffer is already registered as draw buffer. ' +
                'You may forgot to unbind the binding while previous operations.');
        var gl = this.handler.gl;
        if (!this.texture)
            this.allocateTexture();
        gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texture, 0);
        this.isBoundToDrawFrameBuffer = true;
    };
    BufferWebGL.prototype.unbindFromDrawTexture = function () {
        if (!this.isBoundToDrawFrameBuffer)
            return;
        var gl = this.handler.gl;
        gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
        this.isBoundToDrawFrameBuffer = false;
    };
    BufferWebGL.prototype.pack = function (array) {
        var elementStride = this.pixelStride / this.elementsPerPixel;
        if (elementStride === 1) {
            return new Float32Array(array);
        }
        else {
            var result = new Float32Array(array.length * elementStride);
            for (var i = 0; i < array.length; i++)
                result[i * elementStride] = array[i];
            return result;
        }
    };
    BufferWebGL.prototype.unpack = function (array) {
        // FIXME(Kiikurage): more readable code
        var PIXEL_STRIDE = 4;
        var elementStride = PIXEL_STRIDE / this.elementsPerPixel;
        if (elementStride === 1) {
            return new Float32Array(array);
        }
        else {
            var result = new Float32Array(array.length / elementStride);
            for (var i = 0; i < array.length / elementStride; i++)
                result[i] = array[i * elementStride];
            return result;
        }
    };
    BufferWebGL.prototype.allocateTexture = function () {
        if (this.texture)
            throw Error('Texture is already allocated.');
        this._texture = this.handler.createTexture(this.textureWidth, this.textureHeight, this.textureInternalFormat, this.textureFormat);
    };
    return BufferWebGL;
}(buffer_1.Buffer));
exports.default = BufferWebGL;
