"use strict";
/**
 * @module webdnn
 */
/** Don't Remove This comment block */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var webmetal_handler_1 = require("../webmetal_handler");
var buffer_1 = require("./buffer");
/**
 * @protected
 */
var BufferWebMetal = /** @class */ (function (_super) {
    __extends(BufferWebMetal, _super);
    function BufferWebMetal(byteLength) {
        var _this = _super.call(this, byteLength, 'webgpu') || this;
        if (byteLength == 0) {
            byteLength = 4; //0 length buffer causes error
        }
        _this.handler = webmetal_handler_1.default.getInstance();
        _this.buffer = _this.handler.createBuffer(new Uint8Array(byteLength));
        _this.bufferView = new Uint8Array(_this.buffer.contents);
        return _this;
    }
    // async: there may be platforms synchronization is needed before writing
    BufferWebMetal.prototype.write = function (src, dst_offset) {
        return __awaiter(this, void 0, void 0, function () {
            var viewSameType;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.handler.sync()];
                    case 1:
                        _a.sent();
                        viewSameType = new src.constructor(this.bufferView.buffer);
                        viewSameType.set(src, dst_offset);
                        return [2 /*return*/];
                }
            });
        });
    };
    BufferWebMetal.prototype.read = function (dst, src_offset, length) {
        if (src_offset === void 0) { src_offset = 0; }
        return __awaiter(this, void 0, void 0, function () {
            var dstConstructor, viewSameType;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!dst)
                            throw new Error('dst cannot be null');
                        return [4 /*yield*/, this.handler.sync()];
                    case 1:
                        _a.sent();
                        if (this.byteLength === 0)
                            return [2 /*return*/];
                        dstConstructor = dst.constructor;
                        viewSameType = new dstConstructor(this.bufferView.buffer, this.bufferView.byteOffset + src_offset * dstConstructor.BYTES_PER_ELEMENT, length);
                        dst.set(viewSameType);
                        return [2 /*return*/];
                }
            });
        });
    };
    BufferWebMetal.prototype.getWriteView = function (offset, length, type) {
        return new type(this.bufferView.buffer, this.bufferView.byteOffset + offset * type.BYTES_PER_ELEMENT, length);
    };
    BufferWebMetal.prototype.getReadView = function (offset, length, type) {
        return new type(this.bufferView.buffer, this.bufferView.byteOffset + offset * type.BYTES_PER_ELEMENT, length);
    };
    BufferWebMetal.prototype.syncWriteViews = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    BufferWebMetal.prototype.syncReadViews = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    // if the user awaits promise from final kernel execution, this function call is not needed.
                    return [4 /*yield*/, this.handler.sync()];
                    case 1:
                        // if the user awaits promise from final kernel execution, this function call is not needed.
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return BufferWebMetal;
}(buffer_1.Buffer));
exports.default = BufferWebMetal;
