"use strict";
/**
 * @module webdnn
 */
/** Don't Remove This comment block */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var localforage = require("localforage");
var get_weight_decoder_1 = require("../decoder/get_weight_decoder");
var fetch_1 = require("../fetch");
var placeholder_1 = require("../placeholder");
var symbolic_float32array_1 = require("../symbolic_typed_array/symbolic_float32array");
var descriptor_runner_1 = require("./descriptor_runner");
/**
 * @private
 */
function wait(duration) {
    if (duration === void 0) { duration = 10; }
    // let console.log to be displayed, and prevent freeze
    return new Promise(function (resolve) { return setTimeout(resolve, duration); });
}
/**
 * @protected
 */
var DescriptorRunnerFallback = /** @class */ (function (_super) {
    __extends(DescriptorRunnerFallback, _super);
    function DescriptorRunnerFallback(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, options) || this;
        _this.backendName = 'fallback';
        return _this;
    }
    DescriptorRunnerFallback.checkAvailability = function () {
        return true;
    };
    DescriptorRunnerFallback.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    DescriptorRunnerFallback.prototype.setDescriptorAndParameters = function (descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.setDescriptor(descriptor);
                        return [4 /*yield*/, this.compile()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.initializeStaticBuffer(parameters)];
                    case 2:
                        _a.sent();
                        if (!(this.placeholderContext && this.placeholderContext.isResolved)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.initializeDynamicBuffer()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.fetchDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.directory = directory;
                        return [4 /*yield*/, fetch_1.default(directory + "/graph_" + this.backendName + ".json", this.transformUrlDelegate)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.fetchParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch_1.default(directory + "/weight_" + this.backendName + ".bin", this.transformUrlDelegate)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, fetch_1.readArrayBufferProgressively(res, progressCallback)];
                }
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerFallback.prototype.restoreCachedDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, localforage.getItem(directory + "_" + this.backendName + "_descriptor").catch(function () { return null; })];
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerFallback.prototype.restoreCachedParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var parameter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, localforage.getItem(directory + "_" + this.backendName + "_parameters").catch(function () { return null; })];
                    case 1:
                        parameter = _a.sent();
                        if (parameter && progressCallback)
                            progressCallback(parameter.byteLength, parameter.byteLength);
                        return [2 /*return*/, parameter];
                }
            });
        });
    };
    /**
     * save cache
     */
    DescriptorRunnerFallback.prototype.saveCache = function (directory, descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all([
                            localforage.setItem(directory + "_" + this.backendName + "_descriptor", descriptor),
                            localforage.setItem(directory + "_" + this.backendName + "_parameters", parameters)
                        ])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    DescriptorRunnerFallback.prototype.setDescriptor = function (descriptor) {
        this.descriptor = descriptor;
        // reset
        this.placeholderContext = new placeholder_1.default();
        this.placeholderContext.update(descriptor.placeholders);
        this.kernelObj = null;
        this.variableMap = null;
        this.staticBuffer = null;
        this.dynamicBuffer = null;
    };
    DescriptorRunnerFallback.prototype.compile = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        return [4 /*yield*/, new Promise(function (resolve) {
                                var script = document.createElement("script");
                                script.type = "text/javascript";
                                if (script.readyState) { //IE
                                    script.onreadystatechange = function () {
                                        if (script.readyState == "loaded" || script.readyState == "complete") {
                                            script.onreadystatechange = null;
                                            resolve();
                                        }
                                    };
                                }
                                else { //Others
                                    script.onload = resolve;
                                }
                                script.src = _this.transformUrlDelegate(_this.directory + "/kernels_fallback.js");
                                document.getElementsByTagName("head")[0].appendChild(script);
                            })];
                    case 1:
                        _a.sent();
                        this.kernelObj = window.dnn_fallback_kernel; // "window.dnn_fallback_kernel" is defined in "kernels_fallback.js"
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.initializeStaticBuffer = function (weightRawArray) {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, staticBuffer, variableMap, decoder, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        descriptor = this.descriptor;
                        staticBuffer = new Float32Array(descriptor.memory_layout.static.size);
                        this.staticBuffer = staticBuffer;
                        variableMap = this.variableMap || new Map();
                        this.variableMap = variableMap;
                        Object.entries(descriptor.memory_layout.static.allocations)
                            .forEach(function (_a) {
                            var name = _a[0], allocation = _a[1];
                            variableMap.set(name, new Float32Array(staticBuffer.buffer, allocation.offset * Float32Array.BYTES_PER_ELEMENT, allocation.size));
                        });
                        decoder = get_weight_decoder_1.default(this.descriptor.weight_encoding);
                        _b = (_a = staticBuffer).set;
                        return [4 /*yield*/, decoder.decode(new Uint8Array(weightRawArray))];
                    case 1:
                        _b.apply(_a, [_c.sent()]);
                        return [4 /*yield*/, this.getInputViews()];
                    case 2:
                        (_c.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = staticBuffer.buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 3:
                        (_c.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = staticBuffer.buffer;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.initializeDynamicBuffer = function () {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, placeholderContext, dynamicBuffer, variableMap;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        if (!this.placeholderContext)
                            throw new Error('PlaceholderContext is not initialized');
                        descriptor = this.descriptor;
                        placeholderContext = this.placeholderContext;
                        dynamicBuffer = new Float32Array(placeholderContext.resolve(descriptor.memory_layout.dynamic.size));
                        this.dynamicBuffer = dynamicBuffer;
                        variableMap = this.variableMap || new Map();
                        this.variableMap = variableMap;
                        Object.entries(descriptor.memory_layout.dynamic.allocations)
                            .forEach(function (_a) {
                            var name = _a[0], allocation = _a[1];
                            variableMap.set(name, new Float32Array(dynamicBuffer.buffer, placeholderContext.resolve(allocation.offset) * Float32Array.BYTES_PER_ELEMENT, placeholderContext.resolve(allocation.size)));
                        });
                        return [4 /*yield*/, this.getInputViews()];
                    case 1:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = dynamicBuffer.buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 2:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = dynamicBuffer.buffer;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.setPlaceholderValue = function (values) {
        return __awaiter(this, void 0, void 0, function () {
            var placeholderContext;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.placeholderContext)
                            throw new Error('placeholderContext is not initialized');
                        placeholderContext = this.placeholderContext;
                        placeholderContext.update(values);
                        if (!placeholderContext.isResolved)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.initializeDynamicBuffer()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var variableMap, placeholderContext, executionInfos, startDate, lastDate, i, currentDate, executionInfo, inputs, outputs;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        if (!this.placeholderContext)
                            throw new Error('placeholderContext is not initialized');
                        if (!this.variableMap)
                            throw new Error('Variable map is not initialized');
                        if (!this.staticBuffer)
                            throw new Error('StaticBuffer map is not initialized');
                        if (!this.dynamicBuffer)
                            throw new Error('DynamicBuffer map is not initialized');
                        variableMap = this.variableMap;
                        placeholderContext = this.placeholderContext;
                        executionInfos = this.descriptor.exec_infos
                            .map(function (executionInfo) { return placeholderContext.resolve(executionInfo); });
                        startDate = Date.now();
                        lastDate = Date.now();
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < executionInfos.length)) return [3 /*break*/, 5];
                        currentDate = Date.now();
                        if (!(currentDate - lastDate >= 1000)) return [3 /*break*/, 3];
                        console.log("Processed " + i + "/" + executionInfos.length + " kernels in " + (currentDate - startDate) + " ms");
                        lastDate = currentDate;
                        return [4 /*yield*/, wait()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3:
                        executionInfo = executionInfos[i];
                        inputs = executionInfo.inputs.map(function (name) { return variableMap.get(name); });
                        outputs = executionInfo.outputs.map(function (name) { return variableMap.get(name); });
                        this.kernelObj[executionInfo.entry_func_name](inputs, outputs, executionInfo.call_option);
                        _a.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 1];
                    case 5:
                        console.log("Processed " + executionInfos.length + "/" + executionInfos.length + " kernels in " + (Date.now() - startDate) + " ms");
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerFallback.prototype.getInputViews = function () {
        if (this.inputs)
            return this.inputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        this.inputs = descriptor.inputs.map(function (name) {
            var allocation = descriptor.memory_layout.static.allocations[name] || descriptor.memory_layout.dynamic.allocations[name];
            var view = new symbolic_float32array_1.default(null, allocation.offset * symbolic_float32array_1.default.BYTES_PER_ELEMENT, allocation.size, placeholderContext);
            return view;
        });
        return this.inputs;
    };
    DescriptorRunnerFallback.prototype.getOutputViews = function () {
        if (this.outputs)
            return this.outputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        this.outputs = descriptor.outputs.map(function (name) {
            var allocation = descriptor.memory_layout.static.allocations[name] || descriptor.memory_layout.dynamic.allocations[name];
            var view = new symbolic_float32array_1.default(null, allocation.offset * symbolic_float32array_1.default.BYTES_PER_ELEMENT, allocation.size, placeholderContext);
            return view;
        });
        return this.outputs;
    };
    return DescriptorRunnerFallback;
}(descriptor_runner_1.DescriptorRunner));
exports.default = DescriptorRunnerFallback;
