"use strict";
/**
 * @module webdnn
 */
/** Don't Remove This comment block */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var localforage = require("localforage");
var get_weight_decoder_1 = require("../decoder/get_weight_decoder");
var fetch_1 = require("../fetch");
var placeholder_1 = require("../placeholder");
var symbolic_float32array_1 = require("../symbolic_typed_array/symbolic_float32array");
var descriptor_runner_1 = require("./descriptor_runner");
/**
 * @protected
 */
var DescriptorRunnerWebassembly = /** @class */ (function (_super) {
    __extends(DescriptorRunnerWebassembly, _super);
    function DescriptorRunnerWebassembly(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, options) || this;
        _this.backendName = 'webassembly';
        _this.worker_promise_reject_func = null;
        _this.worker_initial_error = null;
        if (typeof Worker === 'undefined')
            throw new Error('WebWorker is needed for WebAssembly backend');
        if (typeof WebAssembly !== 'object') {
            console.warn('WebAssembly is not supported on this browser, trying to use asm.js code');
        }
        return _this;
    }
    DescriptorRunnerWebassembly.checkAvailability = function () {
        return 'Worker' in window;
    };
    DescriptorRunnerWebassembly.prototype.init = function () {
        if (!DescriptorRunnerWebassembly.checkAvailability())
            throw Error('WebAssembly backend is not supported in this browser.');
        //nothing to do
        return Promise.resolve();
    };
    // https://qiita.com/sounisi5011/items/e24d0e1dfd71c5dd528e
    // helper function to transform relative path to absolute path
    // FIXME: use URL constructor. URL does not work on IE11, so polyfill is also needed to use it.
    DescriptorRunnerWebassembly.prototype.absolutePath = function (path) {
        var e = document.createElement('span');
        e.insertAdjacentHTML('beforeend', '<a href="' + path + '" />');
        return e.firstChild.href;
    };
    DescriptorRunnerWebassembly.prototype.setDescriptorAndParameters = function (descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            var kernel_backend, worker_entry_js_path, worker_src_fetch, worker_src, map_aux_file_src;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.descriptor = descriptor;
                        this.placeholderContext = new placeholder_1.default(this.descriptor.placeholders);
                        kernel_backend = typeof WebAssembly === 'object' ? 'webassembly' : 'asmjs';
                        if (window.navigator.userAgent.indexOf('iPhone OS 11_2') >= 0) {
                            // workaround for bug in webassembly
                            // https://bugs.webkit.org/show_bug.cgi?id=181781
                            kernel_backend = 'asmjs';
                        }
                        worker_entry_js_path = this.directory + "/kernels_" + kernel_backend + ".js";
                        worker_entry_js_path = this.transformUrlDelegate(worker_entry_js_path);
                        this.worker_entry_js_path = worker_entry_js_path;
                        return [4 /*yield*/, fetch(this.worker_entry_js_path)];
                    case 1:
                        worker_src_fetch = _a.sent();
                        return [4 /*yield*/, worker_src_fetch.text()];
                    case 2:
                        worker_src = _a.sent();
                        map_aux_file_src = function (basename, key) {
                            var file_abs = _this.absolutePath(_this.directory + "/" + basename);
                            var file_abs_transformed = _this.transformUrlDelegate(file_abs); // absolute path is given
                            worker_src = worker_src.replace(key, file_abs_transformed);
                        };
                        if (kernel_backend === 'webassembly') {
                            map_aux_file_src('kernels_webassembly.wasm', 'WEBDNN_URL_KERNELS_WASM');
                        }
                        else {
                            map_aux_file_src('kernels_asmjs.js.mem', 'WEBDNN_URL_KERNELS_ASMJS_MEM');
                        }
                        return [4 /*yield*/, this.compile(worker_src)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.loadWeights(new Uint8Array(parameters))];
                    case 4:
                        _a.sent();
                        return [4 /*yield*/, this.getInputViews()];
                    case 5:
                        //assign buffer to input/output buffer view
                        (_a.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = (new Float32Array(view.length)).buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 6:
                        (_a.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = (new Float32Array(view.length)).buffer;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Fetch graph descriptor from specified directory.
     *
     * @param directory directory where descriptor is contained.
     * You can also provide URL of other domain like this.
     *
     * ```javascript
     * await runner.load('://my.other.domain.com/my_model');
     * ```
     *
     * However sometimes it can't because of Cross-Origin-Resource-Security policy.
     *
     * @protected
     */
    DescriptorRunnerWebassembly.prototype.fetchDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.directory = directory;
                        return [4 /*yield*/, fetch_1.default(directory + "/graph_" + this.backendName + ".json", this.transformUrlDelegate)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    /**
     * Fetch parameter files from specified directory.
     *
     * @param directory directory where descriptor is contained.
     * You can also provide URL of other domain like this.
     *
     * ```javascript
     * await runner.load('://my.other.domain.com/my_model');
     * ```
     *
     * However sometimes it can't because of Cross-Origin-Resource-Security policy.
     *
     * @param progressCallback callback which is called to notice the loading is progressing.
     * @protected
     */
    DescriptorRunnerWebassembly.prototype.fetchParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var weight_url, weight_fetch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        weight_url = directory + "/weight_" + this.backendName + ".bin";
                        return [4 /*yield*/, fetch_1.default(weight_url, this.transformUrlDelegate)];
                    case 1:
                        weight_fetch = _a.sent();
                        return [2 /*return*/, fetch_1.readArrayBufferProgressively(weight_fetch, progressCallback)];
                }
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerWebassembly.prototype.restoreCachedDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.directory = directory;
                return [2 /*return*/, localforage.getItem(directory + "_" + this.backendName + "_descriptor").catch(function () { return null; })];
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerWebassembly.prototype.restoreCachedParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var parameter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, localforage.getItem(directory + "_" + this.backendName + "_parameters").catch(function () { return null; })];
                    case 1:
                        parameter = _a.sent();
                        if (parameter && progressCallback)
                            progressCallback(parameter.byteLength, parameter.byteLength);
                        return [2 /*return*/, parameter];
                }
            });
        });
    };
    /**
     * save cache
     */
    DescriptorRunnerWebassembly.prototype.saveCache = function (directory, descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all([
                            localforage.setItem(directory + "_" + this.backendName + "_descriptor", descriptor),
                            localforage.setItem(directory + "_" + this.backendName + "_parameters", parameters)
                        ])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    DescriptorRunnerWebassembly.prototype.setPlaceholderValue = function (values) {
        return __awaiter(this, void 0, void 0, function () {
            var placeholderContext, descriptor, unresolvedValueLists, metaBufferFillList, _loop_1, kernel_order, dynamicBufferSize;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.placeholderContext)
                            throw new Error('PlaceholderContext is not initialized.');
                        placeholderContext = this.placeholderContext;
                        placeholderContext.update(values);
                        if (!placeholderContext.isResolved)
                            return [2 /*return*/];
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        descriptor = this.descriptor;
                        unresolvedValueLists = descriptor.unresolved_value_lists;
                        metaBufferFillList = [];
                        _loop_1 = function (kernel_order) {
                            var unresolvedValueList = unresolvedValueLists[kernel_order];
                            unresolvedValueList.forEach(function (offset_placeholder) {
                                var resolved_value = placeholderContext.resolve(offset_placeholder.placeholder);
                                metaBufferFillList.push(kernel_order, offset_placeholder.offset, resolved_value);
                            });
                        };
                        for (kernel_order = 0; kernel_order < unresolvedValueLists.length; kernel_order++) {
                            _loop_1(kernel_order);
                        }
                        return [4 /*yield*/, this.getInputViews()];
                    case 1:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = (new Float32Array(view.length)).buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 2:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = (new Float32Array(view.length)).buffer;
                        });
                        dynamicBufferSize = this.placeholderContext.resolve(this.descriptor.memory_layout.dynamic.size);
                        return [4 /*yield*/, this.setPlaceholderValueWorker(dynamicBufferSize, new Int32Array(metaBufferFillList))];
                    case 3:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerWebassembly.prototype.setPlaceholderValueWorker = function (dynamicBufferSize, metaBufferFillArray) {
        if (!this.worker)
            throw Error("Worker is not initialized");
        var worker = this.worker;
        return new Promise(function (resolve, reject) {
            worker.onmessage = function (event) {
                if (event.data === 0) {
                    resolve();
                }
                else {
                    console.log(event.data);
                    worker.terminate();
                    reject(new Error(event.data));
                }
            };
            worker.postMessage({ type: 'set_dynamic_buffer', size: dynamicBufferSize, data: metaBufferFillArray });
        });
    };
    DescriptorRunnerWebassembly.prototype.compile = function (worker_src) {
        var _this = this;
        var blob = new Blob([worker_src], { type: "text/javascript" });
        var blob_url = URL.createObjectURL(blob);
        var worker = new Worker(blob_url);
        worker.onerror = function (event) {
            console.error(event);
            // console.error('Worker Exception: ' + event.message);
            if (_this.worker_promise_reject_func) {
                _this.worker_promise_reject_func(event);
            }
            else {
                _this.worker_initial_error = event;
            }
        };
        var promise = new Promise(function (resolve, reject) {
            // occurs when this.worker_entry_js_path is 404
            if (_this.worker_initial_error)
                return reject(_this.worker_initial_error);
            _this.worker_promise_reject_func = reject;
            worker.onmessage = function (event) {
                if (event.data === 0) {
                    resolve();
                }
                else {
                    console.error(event.data);
                    worker.terminate();
                    reject(new Error(event.data));
                }
            };
        });
        this.worker = worker;
        return promise;
    };
    DescriptorRunnerWebassembly.prototype.loadWeights = function (weightsData) {
        return __awaiter(this, void 0, void 0, function () {
            var decoder, weight_data, worker, promise;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        if (!this.worker)
                            throw new Error('Worker is not initialized');
                        decoder = get_weight_decoder_1.default(this.descriptor.weight_encoding);
                        return [4 /*yield*/, decoder.decode(weightsData)];
                    case 1:
                        weight_data = _a.sent();
                        worker = this.worker;
                        promise = new Promise(function (resolve, reject) {
                            _this.worker_promise_reject_func = reject;
                            worker.onmessage = function (event) {
                                if (event.data === 0) {
                                    resolve();
                                }
                                else {
                                    console.log(event.data);
                                    worker.terminate();
                                    reject(new Error(event.data));
                                }
                            };
                            worker.postMessage({ type: 'weight', data: weight_data }, [weight_data.buffer]);
                        });
                        return [2 /*return*/, promise];
                }
            });
        });
    };
    DescriptorRunnerWebassembly.prototype.getInputViews = function () {
        if (this.inputs)
            return this.inputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        this.inputs = descriptor.inputs.map(function (name) {
            var allocation = descriptor.memory_layout.static.allocations[name] || descriptor.memory_layout.dynamic.allocations[name];
            var view = new symbolic_float32array_1.default(null, 0, allocation.size, placeholderContext);
            return view;
        });
        return this.inputs;
    };
    DescriptorRunnerWebassembly.prototype.getOutputViews = function () {
        if (this.outputs)
            return this.outputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        this.outputs = descriptor.outputs.map(function (name) {
            var allocation = descriptor.memory_layout.static.allocations[name] || descriptor.memory_layout.dynamic.allocations[name];
            var view = new symbolic_float32array_1.default(null, 0, allocation.size, placeholderContext);
            return view;
        });
        return this.outputs;
    };
    DescriptorRunnerWebassembly.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var placeholderContext, descriptor, worker, promise;
            var _this = this;
            return __generator(this, function (_a) {
                // if (this._running) throw new Error('Calling another run() while running.');
                if (!this.descriptor)
                    throw new Error('Descriptor is not loaded');
                if (!this.worker)
                    throw new Error('Worker is not initialized');
                if (!this.placeholderContext.isResolved)
                    throw new Error('Not all placeholder is resolved');
                placeholderContext = this.placeholderContext;
                descriptor = this.descriptor;
                worker = this.worker;
                promise = new Promise(function (resolve, reject) {
                    // TODO: better way not to generate function on every run
                    _this.worker_promise_reject_func = reject;
                    worker.onmessage = function (event) {
                        if (Array.isArray(event.data)) {
                            for (var i = 0; i < event.data.length; i++) {
                                _this.outputs[i].set(event.data[i]);
                            }
                            resolve();
                        }
                        else {
                            console.log(event.data);
                            worker.terminate();
                            reject(new Error(event.data));
                        }
                    };
                    var allocations = [descriptor.memory_layout.static.allocations, descriptor.memory_layout.dynamic.allocations];
                    var inputs = [];
                    for (var i = 0; i < descriptor.inputs.length; i++) {
                        for (var allocation_space = 0; allocation_space < 2; allocation_space++) {
                            var var_alloc = allocations[allocation_space][descriptor.inputs[i]];
                            if (var_alloc) {
                                var symAb = _this.inputs[i];
                                inputs.push({
                                    space: allocation_space,
                                    offset: placeholderContext.resolve(var_alloc.offset),
                                    size: symAb.length,
                                    data: symAb.toActual()
                                });
                                break;
                            }
                        }
                    }
                    var outputs = [];
                    for (var i = 0; i < descriptor.outputs.length; i++) {
                        for (var allocation_space = 0; allocation_space < 2; allocation_space++) {
                            var var_alloc = allocations[allocation_space][descriptor.outputs[i]];
                            if (var_alloc) {
                                var symAb = _this.outputs[i];
                                outputs.push({
                                    space: allocation_space,
                                    offset: placeholderContext.resolve(var_alloc.offset),
                                    size: symAb.length
                                });
                                break;
                            }
                        }
                    }
                    worker.postMessage({ type: 'run', inputs: inputs, outputs: outputs });
                });
                return [2 /*return*/, promise];
            });
        });
    };
    return DescriptorRunnerWebassembly;
}(descriptor_runner_1.DescriptorRunner));
exports.default = DescriptorRunnerWebassembly;
