"use strict";
/**
 * @module webdnn
 */
/** Don't Remove This comment block */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var localforage = require("localforage");
var buffer_webgl_1 = require("../buffer/buffer_webgl");
var get_weight_decoder_1 = require("../decoder/get_weight_decoder");
var fetch_1 = require("../fetch");
var placeholder_1 = require("../placeholder");
var symbolic_float32array_1 = require("../symbolic_typed_array/symbolic_float32array");
var webdnn_1 = require("../webdnn");
var webgl_handler_1 = require("../webgl_handler");
var descriptor_runner_1 = require("./descriptor_runner");
// [x y u v] * [upper-left, lower-left, upper-right, lower-right]
/**
 * @protected
 */
var vertexArray = new Float32Array([
    -1, +1,
    -1, -1,
    +1, +1,
    +1, -1,
]);
/**
 * @protected
 */
var DescriptorRunnerWebGL = /** @class */ (function (_super) {
    __extends(DescriptorRunnerWebGL, _super);
    function DescriptorRunnerWebGL(options) {
        if (options === void 0) { options = {}; }
        var _this = _super.call(this, options) || this;
        _this.backendName = 'webgl';
        return _this;
    }
    DescriptorRunnerWebGL.checkAvailability = function () {
        return webgl_handler_1.default.checkAvailability();
    };
    DescriptorRunnerWebGL.prototype.init = function () {
        return __awaiter(this, void 0, void 0, function () {
            var vertexBuffer;
            return __generator(this, function (_a) {
                if (!DescriptorRunnerWebGL.checkAvailability())
                    throw Error('WebGL backend is not supported in this browser.');
                this.handler = webgl_handler_1.default.getInstance();
                vertexBuffer = this.handler.createArrayBuffer(vertexArray);
                this.handler.bindArrayBuffer(vertexBuffer);
                this.buffers = new Map();
                return [2 /*return*/];
            });
        });
    };
    DescriptorRunnerWebGL.prototype.fetchDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch_1.default(directory + "/graph_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + ".json", this.transformUrlDelegate)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, res.json()];
                }
            });
        });
    };
    DescriptorRunnerWebGL.prototype.fetchParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, fetch_1.default(directory + "/weight_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + ".bin", this.transformUrlDelegate)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, fetch_1.readArrayBufferProgressively(res, progressCallback)];
                }
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerWebGL.prototype.restoreCachedDescriptor = function (directory) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, localforage.getItem(directory + "_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + "_descriptor").catch(function () { return null; })];
            });
        });
    };
    /**
     * Load cached descriptor from WebStorage
     * @protected
     */
    DescriptorRunnerWebGL.prototype.restoreCachedParameters = function (directory, progressCallback) {
        return __awaiter(this, void 0, void 0, function () {
            var parameter;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, localforage.getItem(directory + "_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + "_parameters").catch(function () { return null; })];
                    case 1:
                        parameter = _a.sent();
                        if (parameter && progressCallback)
                            progressCallback(parameter.byteLength, parameter.byteLength);
                        return [2 /*return*/, parameter];
                }
            });
        });
    };
    /**
     * save cache
     */
    DescriptorRunnerWebGL.prototype.saveCache = function (directory, descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, Promise.all([
                            localforage.setItem(directory + "_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + "_descriptor", descriptor),
                            localforage.setItem(directory + "_" + this.backendName + "_" + this.handler.MAX_TEXTURE_SIZE + "_parameters", parameters)
                        ])];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ;
    DescriptorRunnerWebGL.prototype.setDescriptorAndParameters = function (descriptor, parameters) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.setDescriptor(descriptor)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.compile()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.initializeStaticBuffer(parameters)];
                    case 3:
                        _a.sent();
                        if (!(this.placeholderContext && this.placeholderContext.isResolved)) return [3 /*break*/, 5];
                        return [4 /*yield*/, this.initializeDynamicBuffer()];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerWebGL.prototype.initializeStaticBuffer = function (weightRawArray) {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, decoder, weight, buffers, mapping;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        descriptor = this.descriptor;
                        decoder = get_weight_decoder_1.default(this.descriptor.weight_encoding);
                        return [4 /*yield*/, decoder.decode(new Uint8Array(weightRawArray))];
                    case 1:
                        weight = _a.sent();
                        buffers = this.buffers;
                        mapping = descriptor.memory_layout.mapping;
                        Object.entries(descriptor.memory_layout.static.allocations)
                            .forEach(function (_a) {
                            var name = _a[0], _b = _a[1], width = _b.width, height = _b.height, size = _b.size, channel_mode = _b.channel_mode;
                            buffers.set(name, new buffer_webgl_1.default(size * Float32Array.BYTES_PER_ELEMENT, width, height, name, null, channel_mode));
                        });
                        Object.entries(descriptor.constants_map)
                            .forEach(function (_a) {
                            var name = _a[0], _b = _a[1], size = _b.size, byte_offset = _b.byte_offset;
                            buffers.get(name).array.set(new Float32Array(weight.buffer, byte_offset, size));
                        });
                        return [4 /*yield*/, this.getInputViews()];
                    case 2:
                        (_a.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = buffers.get(mapping[view.name]).getWriteView(0, view.length, Float32Array).buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 3:
                        (_a.sent())
                            .filter(function (view) { return !view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = buffers.get(mapping[view.name]).getReadView(0, view.length, Float32Array).buffer;
                        });
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerWebGL.prototype.initializeDynamicBuffer = function () {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor, placeholderContext, buffers, mapping;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.descriptor)
                            throw Error("GraphDescriptor is not loaded.");
                        if (!this.placeholderContext)
                            throw Error("PlaceholderContext is not initialized.");
                        descriptor = this.descriptor;
                        placeholderContext = this.placeholderContext;
                        buffers = this.buffers;
                        mapping = descriptor.memory_layout.mapping;
                        Object.entries(descriptor.memory_layout.dynamic.allocations)
                            .forEach(function (_a) {
                            var name = _a[0], _b = _a[1], width = _b.width, height = _b.height, size = _b.size, channel_mode = _b.channel_mode;
                            buffers.set(name, new buffer_webgl_1.default(placeholderContext.resolve(size) * Float32Array.BYTES_PER_ELEMENT, placeholderContext.resolve(width), placeholderContext.resolve(height), name, null, channel_mode));
                        });
                        return [4 /*yield*/, this.getInputViews()];
                    case 1:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = buffers.get(mapping[view.name]).getWriteView(0, placeholderContext.resolve(view.length), Float32Array).buffer;
                        });
                        return [4 /*yield*/, this.getOutputViews()];
                    case 2:
                        (_a.sent())
                            .filter(function (view) { return view.isDynamic; })
                            .forEach(function (view) {
                            view.buffer = buffers.get(mapping[view.name]).getReadView(0, placeholderContext.resolve(view.length), Float32Array).buffer;
                        });
                        this.buildPipeline();
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerWebGL.prototype.setDescriptor = function (descriptor) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.descriptor = descriptor;
                //reset all datum depend on old descriptor
                this.placeholderContext = new placeholder_1.default(descriptor.placeholders);
                return [2 /*return*/];
            });
        });
    };
    DescriptorRunnerWebGL.prototype.compile = function () {
        return __awaiter(this, void 0, void 0, function () {
            var descriptor;
            var _this = this;
            return __generator(this, function (_a) {
                if (!this.descriptor)
                    throw new Error('Descriptor is not loaded');
                descriptor = this.descriptor;
                this.programs = new Map();
                this.vertexShader = this.handler.createVertexShader("\n            precision highp float;\n            attribute vec2 _xy;\n            void main() { \n              gl_Position = vec4(_xy, 0, 1); \n            }\n        ");
                Object.keys(descriptor.shader_sources)
                    .forEach(function (name) {
                    var fragmentShader = _this.handler.createFragmentShader(descriptor.shader_sources[name]);
                    var program = _this.handler.createProgram(_this.vertexShader, fragmentShader);
                    _this.programs.set(name, program);
                });
                return [2 /*return*/];
            });
        });
    };
    DescriptorRunnerWebGL.prototype.setPlaceholderValue = function (values) {
        return __awaiter(this, void 0, void 0, function () {
            var placeholderContext;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!this.placeholderContext)
                            throw new Error('PlaceholderContext is not initialized.');
                        placeholderContext = this.placeholderContext;
                        placeholderContext.update(values);
                        if (!placeholderContext.isResolved)
                            return [2 /*return*/];
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        return [4 /*yield*/, this.initializeDynamicBuffer()];
                    case 1:
                        _a.sent();
                        // resolve placeholders in execution info
                        if (Object.keys(this.descriptor.placeholders).length > 0)
                            throw Error('Currently, WebGL backend doesn\'t support Placeholder feature.');
                        return [2 /*return*/];
                }
            });
        });
    };
    DescriptorRunnerWebGL.prototype.getInputViews = function () {
        var _this = this;
        if (this.inputs)
            return this.inputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        var mapping = this.descriptor.memory_layout.mapping;
        this.inputs = descriptor.inputs.map(function (name) {
            var view = new symbolic_float32array_1.default(null, 0, _this.buffers.get(mapping[name]).length, placeholderContext);
            view.name = name;
            return view;
        });
        return this.inputs;
    };
    DescriptorRunnerWebGL.prototype.getOutputViews = function () {
        var _this = this;
        if (this.outputs)
            return this.outputs;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        var descriptor = this.descriptor;
        var placeholderContext = this.placeholderContext;
        var mapping = this.descriptor.memory_layout.mapping;
        this.outputs = descriptor.outputs.map(function (name) {
            var view = new symbolic_float32array_1.default(null, 0, _this.buffers.get(mapping[name]).length, placeholderContext);
            view.name = name;
            return view;
        });
        return this.outputs;
    };
    DescriptorRunnerWebGL.prototype.buildPipeline = function () {
        var _this = this;
        if (!this.descriptor)
            throw new Error('Descriptor is not loaded');
        if (!this.placeholderContext)
            throw new Error('PlaceholderContext is not initialized');
        if (!this.placeholderContext.isResolved)
            throw new Error("Not all placeholders are resolved: " + this.placeholderContext);
        var gl = this.handler.gl;
        var buffers = this.buffers;
        var mapping = this.descriptor.memory_layout.mapping;
        var referenceCount = new Map();
        this.runtimeInfo = {
            inputs: this.getInputViews().map(function (view) { return buffers.get(mapping[view.name]); }),
            outputs: this.getOutputViews().map(function (view) { return buffers.get(mapping[view.name]); }),
            programs: this.descriptor.exec_infos.map(function (execInfo) {
                // inputs
                var inputs = execInfo.inputs.map(function (input) {
                    var buffer = buffers.get(mapping[input.variable_name]);
                    if (!referenceCount.has(buffer))
                        referenceCount.set(buffer, 0);
                    referenceCount.set(buffer, referenceCount.get(buffer) + 1);
                    return {
                        buffer: buffer,
                        uniformIndex: input.value
                    };
                });
                //output
                var output = buffers.get(mapping[execInfo.output]);
                // shader
                var program = _this.programs.get(execInfo.shader_name);
                _this.handler.useProgram(program);
                // uniforms
                var uniforms = Object.keys(execInfo.uniforms).map(function (name) {
                    var _a = execInfo.uniforms[name], type = _a.type, value = _a.value;
                    switch (type) {
                        case 'int':
                            return {
                                func: gl.uniform1i,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'float':
                            return {
                                func: gl.uniform1f,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'vec2':
                            return {
                                func: gl.uniform2fv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'vec3':
                            return {
                                func: gl.uniform3fv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'vec4':
                            return {
                                func: gl.uniform4fv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'ivec2':
                            return {
                                func: gl.uniform2iv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'ivec3':
                            return {
                                func: gl.uniform3iv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'ivec4':
                            return {
                                func: gl.uniform4iv,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        case 'sampler2D':
                            return {
                                func: gl.uniform1i,
                                args: [gl.getUniformLocation(program, name), value]
                            };
                        default:
                            throw TypeError("Incompatible type for uniform parameter: " + type);
                    }
                });
                // attributes
                var xyAttribLoc = gl.getAttribLocation(program, '_xy');
                // run
                return {
                    program: program,
                    frameBuffer: _this.handler.createFrameBuffer(),
                    name: execInfo.shader_name,
                    width: output.textureWidth,
                    height: output.textureHeight,
                    inputs: inputs,
                    output: output,
                    xyAttribLoc: xyAttribLoc,
                    uniforms: uniforms,
                    disposable: []
                };
            })
        };
        var _loop_1 = function (runtimeProgramInfo) {
            runtimeProgramInfo.inputs.forEach(function (_a) {
                var buffer = _a.buffer;
                var count = referenceCount.get(buffer) - 1;
                if (count == 0) {
                    runtimeProgramInfo.disposable.push(buffer);
                }
                referenceCount.set(buffer, count);
            });
        };
        for (var _i = 0, _a = this.runtimeInfo.programs; _i < _a.length; _i++) {
            var runtimeProgramInfo = _a[_i];
            _loop_1(runtimeProgramInfo);
        }
    };
    DescriptorRunnerWebGL.prototype.run = function () {
        return __awaiter(this, void 0, void 0, function () {
            var gl, runtimeInfo, _i, _a, buffer, records, totalElapsedTime_1, _b, _c, runtimeProgramInfo, start, _d, _e, _f, buffer, uniformIndex, _g, _h, uniform, elapsedTime, xs, _j, _k, buffer, y, summary, _l, _m, runtimeProgramInfo, _o, _p, _q, buffer, uniformIndex, _r, _s, uniform, _t, _u, buffer, _v, _w, buffer;
            return __generator(this, function (_x) {
                switch (_x.label) {
                    case 0:
                        // if (this._running) throw new Error('Calling another run() while running.');
                        if (!this.descriptor)
                            throw new Error('Descriptor is not loaded');
                        if (!this.placeholderContext)
                            throw new Error('PlaceholderContext is not initialized');
                        if (!this.placeholderContext.isResolved)
                            throw new Error("Not all placeholders are resolved: " + this.placeholderContext);
                        gl = this.handler.gl;
                        runtimeInfo = this.runtimeInfo;
                        if (!(this.runtimeInfo.programs.length > 0)) return [3 /*break*/, 29];
                        _i = 0, _a = runtimeInfo.inputs;
                        _x.label = 1;
                    case 1:
                        if (!(_i < _a.length)) return [3 /*break*/, 4];
                        buffer = _a[_i];
                        return [4 /*yield*/, buffer.syncWriteViews()];
                    case 2:
                        _x.sent();
                        _x.label = 3;
                    case 3:
                        _i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (!webdnn_1.getConfiguration('DEBUG', false)) return [3 /*break*/, 18];
                        records = [];
                        totalElapsedTime_1 = 0;
                        _b = 0, _c = runtimeInfo.programs;
                        _x.label = 5;
                    case 5:
                        if (!(_b < _c.length)) return [3 /*break*/, 17];
                        runtimeProgramInfo = _c[_b];
                        start = performance.now();
                        this.handler.bindFrameBuffer(runtimeProgramInfo.frameBuffer, runtimeProgramInfo.width, runtimeProgramInfo.height);
                        _d = 0, _e = runtimeProgramInfo.inputs;
                        _x.label = 6;
                    case 6:
                        if (!(_d < _e.length)) return [3 /*break*/, 9];
                        _f = _e[_d], buffer = _f.buffer, uniformIndex = _f.uniformIndex;
                        return [4 /*yield*/, buffer.bindToReadTexture(uniformIndex)];
                    case 7:
                        _x.sent();
                        _x.label = 8;
                    case 8:
                        _d++;
                        return [3 /*break*/, 6];
                    case 9:
                        // output
                        runtimeProgramInfo.output.bindToDrawTexture();
                        // shader
                        this.handler.useProgram(runtimeProgramInfo.program);
                        // uniforms
                        for (_g = 0, _h = runtimeProgramInfo.uniforms; _g < _h.length; _g++) {
                            uniform = _h[_g];
                            uniform.func.apply(gl, uniform.args);
                        }
                        // attribute
                        gl.vertexAttribPointer(runtimeProgramInfo.xyAttribLoc, 2, gl.FLOAT, true, 8, 0);
                        gl.enableVertexAttribArray(runtimeProgramInfo.xyAttribLoc);
                        // run
                        gl.drawArrays(gl.TRIANGLE_STRIP, 0, vertexArray.length / 2);
                        return [4 /*yield*/, this.handler.waitForComplete()];
                    case 10:
                        _x.sent();
                        elapsedTime = performance.now() - start;
                        totalElapsedTime_1 += elapsedTime;
                        xs = [];
                        _j = 0, _k = runtimeProgramInfo.inputs;
                        _x.label = 11;
                    case 11:
                        if (!(_j < _k.length)) return [3 /*break*/, 14];
                        buffer = _k[_j].buffer;
                        buffer.unbindFromReadTexture();
                        return [4 /*yield*/, buffer.syncReadViews()];
                    case 12:
                        _x.sent();
                        xs.push(buffer.array.slice());
                        _x.label = 13;
                    case 13:
                        _j++;
                        return [3 /*break*/, 11];
                    case 14:
                        runtimeProgramInfo.output.unbindFromDrawTexture();
                        return [4 /*yield*/, runtimeProgramInfo.output.syncReadViews()];
                    case 15:
                        _x.sent();
                        y = runtimeProgramInfo.output.array.slice();
                        records.push({
                            'Kernel': runtimeProgramInfo.name,
                            'Elapsed time [ms]': elapsedTime,
                            'xs': xs,
                            'y': y
                        });
                        _x.label = 16;
                    case 16:
                        _b++;
                        return [3 /*break*/, 5];
                    case 17:
                        summary = Array.from(Object.values(records.reduce(function (summary, record) {
                            if (!(record['Kernel'] in summary)) {
                                summary[record['Kernel']] = {
                                    'Kernel': record['Kernel'],
                                    'Count': 0,
                                    'Elapsed time [ms]': 0,
                                };
                            }
                            summary[record['Kernel']]['Count']++;
                            summary[record['Kernel']]['Elapsed time [ms]'] += record['Elapsed time [ms]'];
                            return summary;
                        }, {})));
                        summary.forEach(function (record) { return record['Ratio [%]'] = (record['Elapsed time [ms]'] / totalElapsedTime_1).toFixed(2); });
                        console.table(records);
                        console.table(summary);
                        return [3 /*break*/, 25];
                    case 18:
                        _l = 0, _m = runtimeInfo.programs;
                        _x.label = 19;
                    case 19:
                        if (!(_l < _m.length)) return [3 /*break*/, 25];
                        runtimeProgramInfo = _m[_l];
                        this.handler.bindFrameBuffer(runtimeProgramInfo.frameBuffer, runtimeProgramInfo.width, runtimeProgramInfo.height);
                        _o = 0, _p = runtimeProgramInfo.inputs;
                        _x.label = 20;
                    case 20:
                        if (!(_o < _p.length)) return [3 /*break*/, 23];
                        _q = _p[_o], buffer = _q.buffer, uniformIndex = _q.uniformIndex;
                        return [4 /*yield*/, buffer.bindToReadTexture(uniformIndex)];
                    case 21:
                        _x.sent();
                        _x.label = 22;
                    case 22:
                        _o++;
                        return [3 /*break*/, 20];
                    case 23:
                        // output
                        runtimeProgramInfo.output.bindToDrawTexture();
                        // shader
                        this.handler.useProgram(runtimeProgramInfo.program);
                        // uniforms
                        for (_r = 0, _s = runtimeProgramInfo.uniforms; _r < _s.length; _r++) {
                            uniform = _s[_r];
                            uniform.func.apply(gl, uniform.args);
                        }
                        // attribute
                        gl.vertexAttribPointer(runtimeProgramInfo.xyAttribLoc, 2, gl.FLOAT, true, 8, 0);
                        gl.enableVertexAttribArray(runtimeProgramInfo.xyAttribLoc);
                        // run
                        gl.drawArrays(gl.TRIANGLE_STRIP, 0, vertexArray.length / 2);
                        // release buffers and binding
                        // for (let buffer of runtimeProgramInfo.disposable) buffer.releaseGPUMemory();
                        for (_t = 0, _u = runtimeProgramInfo.inputs; _t < _u.length; _t++) {
                            buffer = _u[_t].buffer;
                            buffer.unbindFromReadTexture();
                        }
                        runtimeProgramInfo.output.unbindFromDrawTexture();
                        _x.label = 24;
                    case 24:
                        _l++;
                        return [3 /*break*/, 19];
                    case 25:
                        _v = 0, _w = runtimeInfo.outputs;
                        _x.label = 26;
                    case 26:
                        if (!(_v < _w.length)) return [3 /*break*/, 29];
                        buffer = _w[_v];
                        return [4 /*yield*/, buffer.syncReadViews()];
                    case 27:
                        _x.sent();
                        _x.label = 28;
                    case 28:
                        _v++;
                        return [3 /*break*/, 26];
                    case 29: return [2 /*return*/];
                }
            });
        });
    };
    return DescriptorRunnerWebGL;
}(descriptor_runner_1.DescriptorRunner));
exports.default = DescriptorRunnerWebGL;
