"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @module webdnn/image
 * @preferred
 *
 * Module `WebDNN.Image` provides basic image processing operations like follows.
 *
 * - Load image by various way (File picker dialog, url string, canvas, video, etc.)
 * - Pack image data into TypedArray
 * - Crop and resize.
 * - Show result on canvas element
 *
 */
/** Don't Remove This comment block */
// export * from "./image/canvas" // internal API
__export(require("./image/enums"));
__export(require("./image/image_array"));
// export * from "./image/image_data" // internal API
__export(require("./image/image_source"));
